require 'osx/cocoa'

class PrefsSettingsViewController <  OSX::NSViewController

  ib_outlet :autoLaunch
  ib_outlet :showUnreadCount
  ib_action :saveAutoLaunch
  ib_action :saveShowUnreadCount

  def title
    NSLocalizedString("General")
  end
  
  def image
    NSImage.imageNamed("NSPreferencesGeneral")
  end
  
  def identifier
    PrefsToolbarItemSettings
  end
  
  def loadView
    super_loadView
    @autoLaunch.setTitle(NSLocalizedString("Abrir AirMail"))
    @autoLaunch.setState(GNPreferences.sharedInstance.autoLaunch? ? NSOnState : NSOffState)
    @showUnreadCount.setTitle(NSLocalizedString("_"))
    @showUnreadCount.setState(GNPreferences.sharedInstance.showUnreadCount? ? NSOnState : NSOffState)
  end

  def saveAutoLaunch(sender)
    GNPreferences.sharedInstance.autoLaunch = (@autoLaunch.state == NSOnState)
  end 
  
  def saveShowUnreadCount(sender)
    GNPreferences.sharedInstance.showUnreadCount = (@showUnreadCount.state == NSOnState)
  end
end
